﻿Type=Activity
Version=6.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
	#Extends: android.support.v7.app.AppCompatActivity
#End Region

Sub Process_Globals
	Dim ref As DatabaseReference
	Dim tempuserref As DatabaseReference 
End Sub

Sub Globals
	Dim xml As XmlLayoutBuilder
	
	Private Content As Panel
	Private Toolbar As ACToolBarLight
	
	Private DSFloatingActionButton1 As DSFloatingActionButton
	Private MaskedEditText1 As MaskedEditText
	Private MaskedEditText2 As MaskedEditText
End Sub

Sub Activity_Create(FirstTime As Boolean)
	' ─────────────────
	' Load basic layout 
	' ─────────────────
	Activity.LoadLayout("postnew")
	Toolbar.Color = 0xFF039BE5
	Toolbar.TitleTextColor = Colors.White
	Toolbar.Title = Starter.mapCurrentUser.get("DisplayName")
	Toolbar.InitMenuListener

	Dim bd As BitmapDrawable = xml.GetDrawable("ic_navigation_check_24")
	DSFloatingActionButton1.SetIcon(bd)

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Initialize
	Log("#-PostsNew.Initialize")
	PrepRefOnTopnode("")
		
End Sub

Sub DSFloatingActionButton1_Click
	Log("#-DSFloatingActionButton1_Click")
	
	If validateForm Then 
		' Create post and close activity
		Dim bolWpOk As Boolean = writeNewPost(Starter.mapCurrentUser.GetDefault("Uid", ""), Starter.mapCurrentUser.GetDefault("DisplayName", ""), MaskedEditText1.Text, MaskedEditText2.Text)
		Log("#-  bolWpOk=" & bolWpOk)
		Activity.Finish
	End If
	
End Sub

Sub validateForm As Boolean 
	If MaskedEditText1.Text.Length = 0 Then
		MaskedEditText1.ShowError("Required")
		Return False
	End If
 
	If MaskedEditText2.Text.Length = 0 Then
		MaskedEditText2.ShowError("Required")
		Return False
	End If
 
 	Return True
End Sub

Sub MaskedEditText1_EnterPressed
	MaskedEditText2.RequestFocus
End Sub
Sub MaskedEditText2_EnterPressed
	DSFloatingActionButton1_Click
End Sub

Sub writeNewPost(strUid As String, strUNam As String, strTitle As String, strBody As String) As Boolean 
	Log("#-writeNewPost, strUid=" & strUid & ", strUNam=" & strUNam & ", strTitle=" & strTitle & ", strBody=" & strBody)	
	'  
   	Dim tempref As DatabaseReference = ref.Child("posts") ' <-- One node we want to write the data to
    Dim posts As DatabaseReference = tempref.push         ' <-- We just needed this reference to get the autogenerated KEY
    Dim key As String = posts.Key 
    Log("#-  key=" & key) 

    Dim mapPostValues As Map
    mapPostValues.Initialize
    mapPostValues.Put("uid", strUid)
    mapPostValues.Put("author", strUNam)
    mapPostValues.Put("title", strTitle)
    mapPostValues.Put("body", strBody)
    mapPostValues.Put("starCount", "0")

    ' "Fanout" the data to different paths (NoSQL recommendation for up to 1 million simultaneous users)  --> https://firebase.googleblog.com/2015/10/client-side-fan-out-for-data-consistency_73.html
    Dim strUk1 As String = "/posts/" & key
    Dim strUk2 As String = "/user-posts/" & strUid & "/" & key
    Log("#-  strUk1=" & strUk1) 
    Log("#-  strUk2=" & strUk2) 
 
    Dim childUpdates As Map
    childUpdates.Initialize
    childUpdates.Put(strUk1, mapPostValues)
    childUpdates.Put(strUk2, mapPostValues)
    ref.updateChildren(childUpdates)      ' <-- This is the "atomic" update. ONE start of transaction no matter how many elements the map has
    'Log("#-  childUpdates=" & childUpdates)	
	
	Return True
	
End Sub

Sub PrepRefOnTopnode(strNewTopNode As String)
	Log("#-PrepRefOnTopnode, strNewTopNode=" & strNewTopNode)
	
	' First make us a reference to the TopLevelNode
    ref.Initialize("Reference", Starter.realtime.getReferencefromUrl($"https://${Starter.strFirebaseProjectId}.firebaseio.com/${strNewTopNode}"$) )
    ref.addChildEventListener
    ref.addListenerForSingleValueEvent
    ref.addValueEventListener	
 
	'  Make sure the UserId is in the "users" list
	Dim strUidPath As String = "users/" & Starter.mapCurrentUser.GetDefault("Uid", "-1")  ' <--Point A
	Log("#-  strUidPath=" & strUidPath)
	tempuserref.Initialize("tempuserref" , ref.Child(strUidPath) ) ' e.g. <-- https://yyymyprojectid123.firebaseio.com/testnode1/users/-KTclQUDpdelku0RSZ5fq
	tempuserref.Value = Starter.mapCurrentUser ' <-- We just set the map with the userinfo as "the value" and it will be added or updated to the path above (Point A) automatically by Firebase
	Log("#-  tempuserref.Key=" & tempuserref.Key)
	
End Sub