﻿Type=Activity
Version=6.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True	
	#Extends: android.support.v7.app.AppCompatActivity
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	Dim ref As DatabaseReference
	Dim tempuserref As DatabaseReference 	
	Dim refRecent As DatabaseReference 	
	
	Dim panActive As Panel
	Dim xml As XmlLayoutBuilder
		
	Private DSFloatingActionButton1 As DSFloatingActionButton
	Private VP As AHViewPager
	Private PC As AHPageContainer
	Private TabLayout As DSTabLayout
	Private Toolbar As ACToolBarLight
	Private CustomListView1 As CustomListView
	
	Private imgStar As ImageView
	Private imgUserPic As ImageView
	Private lblPostText As Label
	Private lblPostTitle As Label
	Private lblStarCount As Label
	Private lblUsername As Label
	Private panCustListCell As Panel
	
	Private lblHiddenId As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	' ─────────────────
	' Load basic layout 
	' ─────────────────
	Activity.LoadLayout("postsmain")
	Toolbar.Color = 0xFF039BE5
	Toolbar.TitleTextColor = Colors.White
	Toolbar.Title = Starter.mapCurrentUser.get("DisplayName")
	Toolbar.InitMenuListener
	
	Dim bd As BitmapDrawable = xml.GetDrawable("ic_image_edit")
	DSFloatingActionButton1.SetIcon(bd)

	
	' ──────────────────────
	' Prep the PageContainer
	' ──────────────────────
	PC.Initialize
	Dim p1 As Panel
	p1.Initialize("")
	PC.AddPage(p1, "RECENT") 
	
	Dim p2 As Panel
	p2.Initialize("")
	PC.AddPage(p2, "MY POSTS") 
	
	VP.PageContainer = PC
	
	Dim ac As AppCompat
	TabLayout.Color = ac.GetThemeAttribute("colorPrimary")
	TabLayout.SetTabTextColors(Colors.LightGray, Colors.White)
	TabLayout.SetViewPager(VP)
	
	' ─────────────────────
	' Prep the ActionButton
	' ─────────────────────
	Dim x As String = Starter.mapCurrentUser.GetDefault("DisplayName", "")
	If x.StartsWith("(") Then 
		DSFloatingActionButton1.Hide
	Else
		DSFloatingActionButton1.Show
	End If
	
End Sub

Sub Activity_Resume
End Sub

Sub Activity_Pause (UserClosed As Boolean)
End Sub

Sub Initialize
	Log("#-PostsMain.Initialize")
	
	' First make a reference to the TopLevelNode
    ref.Initialize("Reference", Starter.realtime.getReferencefromUrl($"https://${Starter.strFirebaseProjectId}.firebaseio.com/"$) )
    ref.addChildEventListener
    ref.addListenerForSingleValueEvent
    ref.addValueEventListener	
	
	' Now we want to make sure the user is in the list "users"
	Dim strUidPath As String = "users/" & Starter.mapCurrentUser.GetDefault("Uid", "-1")  ' <--Point A
	tempuserref.Initialize("tempuserref" , ref.Child(strUidPath) ) ' e.g. <-- https://yyymyprojectid123.firebaseio.com/testnode1/users/-KTclQUDpdelku0RSZ5fq
	tempuserref.Value = Starter.mapCurrentUser ' <-- We just set the map with the userinfo as the "Value" and it will be added or updated to the path above (Point A) automatically by Firebase
	
	VP_PageChanged(0)
	
End Sub

Sub tempuserref_oncomplete(errorCode As Int, errorMessage As String, errObj As Object) ', dbRef As Object)
	Log(" ")
    Log($"#- ═── tempuserref_onComplete(${errorCode}, '${errorMessage}')"$)
    If errObj <> Null Then
        Dim err As DatabaseError = errObj
        Log($"#-  err.Code   =${err.Code}"$)
        Log($"#-  err.Details=${err.Details}"$)
        Log($"#-  err.Message=${err.Message}"$)
    End If
End Sub

Sub showSnapshot(snapX As DataSnapshot)
	Dim snap As DataSnapshot = snapX
	Log("#-Snapshot:" & CRLF & snap.Value & CRLF )
End Sub

Sub DSFloatingActionButton1_Click
	Log("#- PostsMain.DSFloatingActionButton1_Click──┐")
	CallSubDelayed(PostNew, "Initialize")
	
End Sub

Sub panCustListCell_Click
	Log("#-panCustListCell_Click")
	Dim index As Int = CustomListView1.GetItemFromView(Sender)
	Log("#-  CustomListView1.GetValue(index)=" & CustomListView1.GetValue(index))

	' Find needed views via tag	
	Dim pnl As Panel = CustomListView1.GetPanel(index)
	For Each v As View In pnl.GetAllViewsRecursive
		Dim vX As View = v
		If vX Is Label Then 
			Select Case True
			Case vX.Tag = "lblPostText"
				Dim lblPostText As Label = vX
			Case vX.Tag = "lblPostTitle"
				Dim lblPostTitle As Label = vX
			Case vX.Tag = "lblUsername"
				Dim lblUsername As Label = vX
			Case vX.Tag = "lblHiddenId"
				Dim lblHiddenId As Label = vX
			End Select
		End If
	Next

	' Open activity for comments on the clicked post
	Dim mapParameters As Map
	mapParameters.Initialize
	mapParameters.Put("itemValue", CustomListView1.GetValue(index))
	mapParameters.Put("lblPostText.Text", lblPostText.Text)
	mapParameters.Put("lblPostTitle.Text", lblPostTitle.Text)
	mapParameters.Put("lblUsername.Text", lblUsername.Text)
	mapParameters.Put("lblHiddenId.Text", lblHiddenId.Text)
	CallSubDelayed2(PostDetails, "Initialize", mapParameters)
	
End Sub

#If Java
public boolean _onCreateOptionsMenu(android.view.Menu menu) {
	if (processBA.subExists("activity_createmenu")) {
		processBA.raiseEvent2(null, true, "activity_createmenu", false, new de.amberhome.objects.appcompat.ACMenuWrapper(menu));
		return true;
	}
	else
		return false;
}
#End If
Sub Activity_CreateMenu(Menu As ACMenu)
	Menu.Clear
	Menu.Add(1, 3, "leave", Null)
End Sub
Sub Toolbar_MenuItemClick (Item As ACMenuItem)
	Log($"#-PostsMain.Toolbar_MenuItemClick──┐   Item.Id=${Item.Id}, Starter.bolIsAuthEx=${Starter.bolIsAuthEx}"$)
	Select Case Item.Id
	Case 1
		Activity.Finish
	End Select
End Sub

Sub TabLayout_TabSelected(Index As Int, SelectedTab As String, Tag As Object)
	Log($"#-TabLayout_TabSelected, Index=${Index}, SelectedTab=${SelectedTab}"$)
	Select Case Index
	Case 0
		
	Case 1
		
	End Select
	
End Sub

Sub CreateListItem(strPostId As String, strUsername As String, strPostTitle As String, strPostText As String, strStarCount As String, Width As Int, Height As Int) As Panel
	' https://www.b4x.com/android/forum/threads/class-customlistview-a-flexible-list-based-on-scrollview.19567/
	Dim p As Panel
	p.Initialize("")
	'we need to add the panel to a parent to set its dimensions. It will be removed after the layout is loaded.
	Activity.AddView(p, 0, 0, Width, Height)
	p.LoadLayout("CellItem")
	p.RemoveView
	
	' lblPostText etc. will point to the last added views
	lblPostText.Text = strPostTitle
	lblPostTitle.Text = strPostTitle
	lblUsername.Text = strUsername 
	lblHiddenId.Text = strPostId
		
	If strStarCount > 0 Then
		Dim bd As BitmapDrawable = xml.GetDrawable("ic_toggle_star_24")	
		lblStarCount.Text = strStarCount
	Else
		Dim bd As BitmapDrawable = xml.GetDrawable("ic_toggle_star_outline_24")	
		lblStarCount.Text = ""
	End If
	imgStar.Visible = True
	imgStar.Background = bd

	Dim bd As BitmapDrawable = xml.GetDrawable("ic_action_account_circle_40")	' Default user picture
	imgUserPic.Background = bd
	
	Return p
End Sub
'
Sub refRecent_onCancelled(errnum As Int,error As String)
	Log(" ")
    Log($"#- ═── refRecent_onCancelled(${errnum},${error})"$)
End Sub
Sub refRecent_onChildAdded(snapshot As Object, child As String)
	Log(" ")
	Log($"#- ═── refRecent_onChildAdded(${child})"$)
	showSnapshot(snapshot)
End Sub
Sub refRecent_onChildChanged(snapshot As Object, child As String)
	Log(" ")
    Log($"#- ═── refRecent_onChildChanged(${child})"$) 
	showSnapshot(snapshot)
End Sub
Sub refRecent_onChildMoved(snapshot As Object, child As String)
	Log(" ")
    Log($"#- ═── refRecent_onChildMoved(${child})"$) 
	showSnapshot(snapshot)
End Sub
Sub refRecent_onChildRemoved(snapshot As Object)
	Log(" ")
    Log($"#- ═── refRecent_onChildRemoved()"$)
	showSnapshot(snapshot)
End Sub
Sub refRecent_onDataChange(snapshot As Object)
	Log(" ")
    Log($"#- ═── refRecent_onDataChange()"$)
	showSnapshot(snapshot)
End Sub
'
Sub Reference_onCancelled(errnum As Int,error As String)
	Log(" ")
    Log($"#- ═── Reference_onCancelled(${errnum},${error})"$)
End Sub
Sub Reference_onChildAdded(snapshot As Object, child As String)
	Log(" ")
	Log($"#- ═── Reference_onChildAdded(${child})"$)
	showSnapshot(snapshot)
End Sub
Sub Reference_onChildChanged(snapshot As Object, child As String)
	Log(" ")
    Log($"#- ═── Reference_onChildChanged(${child})"$) 
	showSnapshot(snapshot)
End Sub
Sub Reference_onChildMoved(snapshot As Object, child As String)
	Log(" ")
    Log($"#- ═── Reference_onChildMoved(${child})"$) 
	showSnapshot(snapshot)
End Sub
Sub Reference_onChildRemoved(snapshot As Object)
	Log(" ")
    Log($"#- ═── Reference_onChildRemoved()"$)
	showSnapshot(snapshot)
End Sub
Sub Reference_onDataChange(snapshot As Object)
	Log(" ")
    Log($"#- ═── Reference_onDataChange()"$)
	showSnapshot(snapshot)
End Sub
Sub Reference_onComplete(errorCode As Int, errorMessage As String, errObj As Object, dbref As Object)
    Log($"#-Reference_onComplete(${errorCode},${errorMessage})"$)
    If errObj <> Null Then
        Dim err As DatabaseError = errObj
        Log($"#-  err.Code   =${err.Code}"$)
        Log($"#-  err.Details=${err.Details}"$)
        Log($"#-  err.Message=${err.Message}"$)
    End If
    If dbref <> Null Then
        Dim ref As DatabaseReference = dbref
        Log($"  ref.Key=${ref.Key}"$)
    End If
End Sub

 Sub VP_PageChanged (Position As Int)
	Log($"#-VP_PageChanged, Position=${Position}"$)	
	panActive = PC.GetPageObject(Position)
	panActive.LoadLayout("custlv")


	'#### Only local TESTDATA to verify the function of the CustomListView ####	
	'#### Only local TESTDATA to verify the function of the CustomListView ####	
	'#### Only local TESTDATA to verify the function of the CustomListView ####	
	For i= 1 To 3
		CustomListView1.Add(CreateListItem("-KTxy" & (i*121), "Testuser xyz", "Test Posttitle no. " & i, "Test Posttext lorem ipsum lorem ipsum lorem ipsum lorem ipsum", (i*11), CustomListView1.AsView.Width, 136dip ), 136dip, i)
	Next
	'#### Only local TESTDATA to verify the function of the CustomListView ####	

	
	' x280
	'
	' ...unfinished: Here should be a Query of "posts" to get the snapshot-data to fill the CustomListView1 with the content of the childnodes
	'
	'refRecent.Initialize("refRecent" , ref.Child("posts") ) 
	'refRecent.LimitToFirst(3) 
	' ..query...
	' ...


	
End Sub
